searchNodes=[{"doc":"Elixir implementation of Ethereum's RLP (Recursive Length Prefix) encoding.","ref":"ExRLP.html","title":"ExRLP","type":"module"},{"doc":<<71, 105, 118, 101, 110, 32, 97, 110, 32, 82, 76, 80, 45, 101, 110, 99, 111, 100, 101, 100, 32, 115, 116, 114, 105, 110, 103, 44, 32, 114, 101, 116, 117, 114, 110, 115, 32, 97, 32, 100, 101, 99, 111, 100, 101, 100, 32, 82, 80, 76, ...>>,"ref":"ExRLP.html#decode/2","title":"ExRLP.decode/2","type":"function"},{"doc":<<71, 105, 118, 101, 110, 32, 97, 110, 32, 82, 76, 80, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 32, 40, 105, 46, 101, 46, 32, 97, 110, 121, 116, 104, 105, 110, 103, 41, 44, 32, 114, 101, 116, 117, 114, 110, 115, 32, 116, 104, ...>>,"ref":"ExRLP.html#encode/2","title":"ExRLP.encode/2","type":"function"},{"doc":"","ref":"ExRLP.html#t:t/0","title":"ExRLP.t/0","type":"type"},{"doc":"Captures bins and decodes them.","ref":"ExRLP.DecodeItem.html","title":"ExRLP.DecodeItem","type":"module"},{"doc":"","ref":"ExRLP.DecodeItem.html#decode_item/1","title":"ExRLP.DecodeItem.decode_item/1","type":"function"},{"doc":"","ref":"ExRLP.Encode.html","title":"ExRLP.Encode","type":"protocol"},{"doc":"","ref":"ExRLP.Encode.html#encode/2","title":"ExRLP.Encode.encode/2","type":"function"},{"doc":"","ref":"ExRLP.Encode.html#t:t/0","title":"ExRLP.Encode.t/0","type":"type"},{"doc":"Raised if an invalid RLP encoding is detected, as in https://github.com/ethereum/wiki/wiki/rlp .","ref":"ExRLP.DecodeError.html","title":"ExRLP.DecodeError","type":"exception"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Remove deprecated config file ( https://github.com/mana-ethereum/ex_rlp/pull/35 )","ref":"changelog.html#0-5-4-2022-02-13","title":"Changelog - 0.5.4 - 2022-02-13","type":"extras"},{"doc":"Handle invalid RLP when decoding (with respective tests from ethereum/tests ) ( https://github.com/mana-ethereum/ex_rlp/pull/27 ) Update ethereum/tests submodule ( https://github.com/mana-ethereum/ex_rlp/pull/23 and https://github.com/mana-ethereum/ex_rlp/pull/25 )","ref":"changelog.html#0-5-3-2020-02-07","title":"Changelog - 0.5.3 - 2020-02-07","type":"extras"},{"doc":"reverts https://github.com/mana-ethereum/ex_rlp/pull/20 which introduced encoding bug ( https://github.com/mana-ethereum/ex_rlp/pull/22 ) defensive guard checking in encoder ( https://github.com/mana-ethereum/ex_rlp/pull/21 )","ref":"changelog.html#0-5-2-2019-01-19","title":"Changelog - 0.5.2 - 2019-01-19","type":"extras"},{"doc":"Fix encoding of binary lists with trailing zeroes ( https://github.com/mana-ethereum/ex_rlp/pull/20 )","ref":"changelog.html#0-5-1-2018-11-30","title":"Changelog - 0.5.1 - 2018-11-30","type":"extras"},{"doc":"Optimize decoding ( https://github.com/mana-ethereum/ex_rlp/pull/19 )","ref":"changelog.html#0-5-0-2018-11-28","title":"Changelog - 0.5.0 - 2018-11-28","type":"extras"},{"doc":"Fix decoding of large binary lists introduced by changes in 0.4.0. ( https://github.com/mana-ethereum/ex_rlp/pull/17 )","ref":"changelog.html#0-4-1-2018-11-27","title":"Changelog - 0.4.1 - 2018-11-27","type":"extras"},{"doc":"Improve speed with list prefixing and tail-call optimizations. ( https://github.com/mana-ethereum/ex_rlp/pull/15 )","ref":"changelog.html#0-4-0-2018-11-23","title":"Changelog - 0.4.0 - 2018-11-23","type":"extras"},{"doc":"Upgrade elixir version. ( https://github.com/exthereum/ex_rlp/pull/14 )","ref":"changelog.html#0-3-1-2018-10-18","title":"Changelog - 0.3.1 - 2018-10-18","type":"extras"},{"doc":"Remove protocols for Map because it overrides custom struct protocols. ( https://github.com/exthereum/ex_rlp/pull/12 )","ref":"changelog.html#0-3-0-2018-05-01","title":"Changelog - 0.3.0 - 2018-05-01","type":"extras"},{"doc":"Improve typespecs to allow for integers as a valid value to encode in RLP. ( https://github.com/exthereum/ex_rlp/pull/6 )","ref":"changelog.html#0-2-1-2017-08-05","title":"Changelog - 0.2.1 - 2017-08-05","type":"extras"},{"doc":"Breaking: added option to encode RLP to either hex strings ( &quot;8055FF&quot; ) or binaries ( &lt;&lt;0x80, 0x55, 0xFF&gt; ). The default is now :binary . ( https://github.com/exthereum/ex_rlp/pull/3 ) Added typespecs and additional test coverage through doctests. ( https://github.com/exthereum/ex_rlp/pull/3 )","ref":"changelog.html#0-2-0-2017-08-02","title":"Changelog - 0.2.0 - 2017-08-02","type":"extras"},{"doc":"Adds protocols for encoding/decoding maps ( https://github.com/exthereum/ex_rlp/commit/76451f707a961a3985e00be4ed3ea77fc27d5c83 )","ref":"changelog.html#0-1-1-2017-06-17","title":"Changelog - 0.1.1 - 2017-06-17","type":"extras"},{"doc":"Copyright © 2017 Geoffrey Hayes, Ayrat Badykov, Mason Forest Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Elixir implementation of Ethereum's RLP (Recursive Length Prefix) encoding. The encoding's specification can be found in the yellow paper or in the ethereum wiki .","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The easiest way to add ExRLP to your project is by using Mix . Add :ex_rlp as a dependency to your project's mix.exs : defp deps do [ { :ex_rlp , &quot;~&gt; 0.5.4&quot; } ] end And run: $ mix deps.get","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Use ExRLP.encode/1 method to encode an item to RLP representation. An item can be non-negative integer, binary or list. List can contain integers, binaries or lists. iex&gt; &quot;dog&quot; |&gt; ExRLP . encode ( encoding : :hex ) &quot;83646f67&quot; iex&gt; &quot;dog&quot; |&gt; ExRLP . encode ( encoding : :binary ) &lt;&lt; 0x83 , 0x64 , 0x6f , 0x67 &gt;&gt; iex&gt; 1000 |&gt; ExRLP . encode ( encoding : :hex ) &quot;8203e8&quot; # Default encoding is binary iex&gt; 1000 |&gt; ExRLP . encode &lt;&lt; 0x82 , 0x03 , 0xe8 &gt;&gt; iex&gt; [ [ [ ] , [ ] ] , [ ] ] |&gt; ExRLP . encode ( encoding : :hex ) &quot;c4c2c0c0c0&quot; Use ExRLP.decode/1 method to decode a RLP encoded data. All items except lists are decoded as binaries so additional deserialization is needed if initially an item of another type was encoded. iex&gt; &quot;83646f67&quot; |&gt; ExRLP . decode ( encoding : :hex ) &quot;dog&quot; iex&gt; &quot;8203e8&quot; |&gt; ExRLP . decode ( encoding : :hex ) |&gt; :binary . decode_unsigned 1000 iex&gt; &quot;c4c2c0c0c0&quot; |&gt; ExRLP . decode ( encoding : :hex ) [ [ [ ] , [ ] ] , [ ] ] More examples can be found in test files.","ref":"readme.html#basic-usage","title":"Overview - Basic Usage","type":"extras"},{"doc":"You can define protocols for encoding/decoding custom data types. defmodule ExRLP.LogEntry do defstruct address : nil , topics : [ ] , data : nil @type t :: % __MODULE__ { address : EVM . address ( ) , topics : [ integer ( ) ] , data : binary ( ) } @spec new ( binary , [ integer ( ) ] , binary ( ) ) :: t ( ) def new ( address , topics , data ) do % __MODULE__ { address : address , topics : topics , data : data } end def to_list ( log ) do [ log . address , log . topics , log . data ] end end defimpl ExRLP.Encode , for : ExRLP.LogEntry do alias ExRLP . { Encode , LogEntry } @spec encode ( LogEntry . t ( ) , keyword ( ) ) :: binary ( ) def encode ( log , options \\\\ [ ] ) do log |&gt; LogEntry . to_list ( ) |&gt; Encode . encode ( options ) end end","ref":"readme.html#protocols","title":"Overview - Protocols","type":"extras"},{"doc":"Fork it! Create your feature branch ( git checkout -b my-new-feature ) Commit your changes ( git commit -am 'Add some feature' ) Push to the branch ( git push origin my-new-feature ) Create new Pull Request","ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras"},{"doc":"Ayrat Badykov (@ayrat555)","ref":"readme.html#author","title":"Overview - Author","type":"extras"},{"doc":"Copyright (c) 2017 Geoffrey Hayes, Ayrat Badykov, Mason Forest ExRLP is released under the MIT License. See the LICENSE.md file for further details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]